#!/bin/bash

. ./hosts.sh

contCnt=1
# GB
pool=`dmg -i pool list -n -j | jq .response.pools[0].uuid -r`
echo "start agent"
for hostAddrs in ${clientHosts[*]}; do
	addrs=`echo $hostAddrs | awk -F[,] '{print $1 " " $2}'`
	addrs=($addrs)
	host=${addrs[0]}
	ssh root@$host "restorecon -rv /usr/bin/; systemctl restart ceastor_agent"
	if [ $? -ne 0 ]; then
		exit
	fi
	sleep 1
	if [[ $1 != "agent" ]] && [ $host = $imageHost ]; then
		for i in $(seq -w $contCnt); do
			contId=`printf "%03d" $i`
			echo "create container BLK$contId"
			ssh root@$host "cbd_test create_contain $pool BLK$contId"
			if [ $? -ne 0 ]; then
				exit 1
			fi
			sleep 1
			for j in $(seq $imageCnt); do
        			imageId=BLK$contId-`printf "%08d" $j`
				size=$[$j-1]
		        	echo "create image $imageId, size=$imageSize"
				ssh root@$host "cbd_test create_image $pool $imageId $imageSize"
				if [ $? -ne 0 ]; then
					exit 1
				fi
			done

		done
	fi
done
echo "***successful***"

