#!/bin/bash

cd `dirname $0`

. ./hosts.sh

engineCnt=$[${#clusterHosts[*]}*2]

for host in ${clusterHosts[*]}; do
        ssh root@$host "rm -rf /mnt/ceastor*/*;"
done
sleep 5
echo "start ceastor"
for host in ${clusterHosts[*]}; do
	ssh root@$host "restorecon -rv /usr/bin/; systemctl restart ceastor_server"
	if [ $? -ne 0 ]; then
		echo "$host start ceastor_server failed"
		exit 1
	fi
done


echo "format"
dmg -i storage format --force

if [ $? != 0 ]; then
	exit
fi

echo "create pool"
sleep 30
while true
do
	ready=`dmg -i sys query -v | grep "Joined" | wc -l`
	if [ $ready -ne $engineCnt ]; then
		sleep 15
		continue
	fi
	dmg -i pool create -p=test -D=/home/zyh/spc/script/pool_create.yml 
	if [ $? != 0 ]; then
	        exit
	fi
	echo "deploy finished"
	break
done
