#!/bin/bash

. ./hosts.sh

spdkPath="/home/zyh/protocol/spdk"
pool=`dmg -i pool list -n -j | jq .response.pools[0].uuid -r`

#Byte
listenAddr=($1 $2)
listenPort=4421

echo 1048576 > /proc/sys/fs/aio-max-nr
devs=`ls /dev/ | grep -e nvme\[0-9]*$`
old=$IFS
IFS=$'\n'
devices=($devs)
for dev in ${devices[@]}; do
        nvme disconnect -d $dev
done
IFS=$old
modprobe nvme-rdma;modprobe nvme-tcp;modprobe nvme-fabrics
if [ $? -ne 0 ]; then
        exit 1
fi
kill -9 `pidof nvmf_tgt`
for t in $(seq $tgtCnt); do
	socket=/var/tmp/tgt_$t.sock
	core='['
	for c in $(seq $tgtCore); do
		let off=\($t-1\)\*\($tgtCore+32\)
		let idx=$off+$c-1
		if [ $c -eq 1 ]; then
			core="$core$idx"
		else
			core="$core,$idx"
		fi
	done
	core="$core]"
	echo "start reactor_$t"
	ip=${listenAddr[$[$t-1]]}
	iface=`ip a | grep $ip/ | awk '{print $8}'`
	export OFI_INTERFACE=$iface
	export OFI_INTERFACE_BAK=$iface
	export OFI_DOMAIN=mlx5_$[$t-1]
	export OFI_DOMAIN_BAK=mlx5_$[$t-1]
        echo "$OFI_INTERFACE    $OFI_INTERFACE_BAK $OFI_DOMAIN $OFI_DOMAIN_BAK"
	nohup $spdkPath/build/bin/nvmf_tgt -m $core -r $socket   >/home/reactor.$t.log 2>&1 &
	if [ $? -ne 0 ]; then
        	exit 1
	fi

	sleep 20
	$spdkPath/scripts/rpc.py -s $socket nvmf_create_transport -t RDMA -u 16384 -m 32 -c 4096
	if [ $? -ne 0 ]; then
        	exit 1
	fi
        upper=$(($t*$tgtImageCnt))
        lower=$(($t-1))
        lower=$(($lower*$tgtImageCnt))
done
nqn_array=[]
for j in $(seq $imageCnt); do
	let tgtIdx=($j-1)%$tgtCnt
	ip=${listenAddr[$tgtIdx]}
	let tgtIdx=$tgtIdx+1
	socket=/var/tmp/tgt_$tgtIdx.sock
	imageId=BLK001-`printf "%08d" $j`
	size=`echo $imageSize | numfmt --from=iec`

	echo "<<<$pool $imageId $imageSize $size>>>"
	echo "$spdkPath/scripts/rpc.py -s $socket bdev_cbd_create -b cbd$j $pool $imageId $size 512"
	$spdkPath/scripts/rpc.py -s $socket bdev_cbd_create -b cbd$j $pool $imageId $size 512
	if [ $? -ne 0 ]; then
		exit 1
	fi
	nqnName=nqn.2014-08.org.nvmexpress:uuid:`uuidgen`
	nqn_array[$j]=$nqnName
	echo "<<<$nqnName>>>"
	echo "$spdkPath/scripts/rpc.py -s $socket nvmf_create_subsystem $nqnName -a -s SPDK0000000000000$j -d SPDK_Controller"
	$spdkPath/scripts/rpc.py -s $socket nvmf_create_subsystem $nqnName -a -s SPDK0000000000000$j -d SPDK_Controller
        if [ $? -ne 0 ]; then
       	        exit 1
        fi

	$spdkPath/scripts/rpc.py -s $socket nvmf_subsystem_add_ns $nqnName cbd$j
        if [ $? -ne 0 ]; then
               	exit 1
       	fi

	echo "listen on $ip:$listenPort"
	echo "$spdkPath/scripts/rpc.py -s $socket nvmf_subsystem_add_listener $nqnName -t rdma -a $ip -s $listenPort"
	$spdkPath/scripts/rpc.py -s $socket nvmf_subsystem_add_listener $nqnName -t rdma -a $ip -s $listenPort
        if [ $? -ne 0 ]; then
               	exit 1
       	fi
	echo "nvme connect..."
done
sleep 30
for j in $(seq $imageCnt); do
        let tgtIdx=($j-1)%$tgtCnt
        ip=${listenAddr[$tgtIdx]}
        let tgtIdx=$tgtIdx+1
        socket=/var/tmp/tgt_$tgtIdx.sock
        imageId=BLK001-`printf "%08d" $j`
        size=`echo $imageSize | numfmt --from=iec`
	nvme connect -t rdma -n "${nqn_array[$j]}" -a $ip -s $listenPort -l 10 -i 16
        echo "$listenPort connect $imageId succeed."
done	

echo "lun map successful"
